/*
 * AKA.NLM 
 *		Allows the fileserver the NLM is loaded on to be known by another name
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sap.h>
#include <nwbindry.h>
#include <conio.h>
#include <process.h>

/* the following value is int-swapped the real value !! */
#define	FILESERVER_SOCKET 0x5104

#define	AH_MAX	16

void	akaEnd(void);

char	*myname,*pmy;
long	ahndList[AH_MAX];

void Usage(void)
{
	ConsolePrintf("usage: %s <name1> .... <name%d>\r\n", myname,AH_MAX);
	exit(1);
};

main(int argc,char *argv[])
{
int i;
/* no screen, use the system console */
	i=CreateScreen("System Console",0);
	SetCurrentScreen(i);
	DisplayScreen(i);

/* tidy up if we exit() or are unloaded */
	ConsolePrintf("AKA.NLM version %s Copyright (c) 1994 University of Salford\r\n",VERSION);

/* initialise list */
	for (i=0;i<AH_MAX;i++) ahndList[i]=-1l;
	atexit(akaEnd);

/* parse the command line */
	myname = *argv;
	if (pmy=strrchr(myname,'\\') ) myname=pmy+1;
		else	if (pmy=strrchr(myname,':'))  myname=pmy+1;

if (argc == 1) Usage();

for (i=1;i<argc;i++) {
	ahndList[i]=AdvertiseService(OT_FILE_SERVER,strupr(argv[i]),FILESERVER_SOCKET);
	if (ahndList[i]==-1) perror(argv[i]);
	};

for (i=0;i<AH_MAX;i++) 
	if (ahndList[i]!=-1l) break;

if (i==AH_MAX) {
	ConsolePrintf("%s: No services advertised");
	exit(1);
	};

SuspendThread(GetThreadID());
}

void	akaEnd(void)
{
int i;

for (i=0;i<AH_MAX;i++) 
	if (ahndList[i]!=-1l) ShutdownAdvertising(ahndList[i]);

ConsolePrintf("%s: NLM Exiting\r\n", myname);
}